import {backURL} from "../actions";
import { select, put, takeEvery } from "redux-saga/effects";
import {store} from "./store";


export const playerReducer = (
    state = {},
    {type,track,trackIndex,isPlaying=false,isPaused,duration,
        playlist,playlistIndex,currentTime=0,volume=1,}) => {

    if (type === "TRACK_PLAY") {
        return {
            ...state,
            isPlaying,
            isPaused: !isPlaying,
        };
    }

    if (type === "TRACK_STOP") {
        return {
            ...state,
            isPaused,
            isPlaying: !isPaused,
        };
    }

    if (type === "TRACK_VOLUME") {
        return {
            ...state,
            volume,
        };
    }

    if (type === "TRACK_DURATION") {
        return {
            ...state,
            duration,
        };
    }

    if (type === "TRACK_CURRENT_TIME") {
        return {
            ...state,
            currentTime,
        };
    }

    if (type === "SET_PLAYLIST") {
        console.log(playlist,'lol')
        return {
            ...state,
            playlist,
        };
    }
    return state;
};


const audio = new Audio()


export const actionTrackPlay = (trackIndex) =>
    ({type:'ACTION_TRACK_PLAY', trackIndex})
export function* trackPlayWorker (action) {
    let {trackIndex} = action
    let {player:{playlist}} = yield select ()
    //  if (playlistIndex !== trackIndex) {
    audio.src = backURL + '/'+ playlist[trackIndex].url
    audio.load()
    audio.ondurationchange = function(){actionSetDuration()}
    audio.ontimeupdate = function(){actionTrackCurrentTime()}
    // }
    yield audio.play()
    console.log(trackIndex,'uuuuu')
    yield put({type:"TRACK_PLAY",isPlaying:true,isPaused:false,trackIndex})
}
export function* trackPlayWatcher() {
    yield takeEvery ('ACTION_TRACK_PLAY',trackPlayWorker)
}





export const actionTrackStop = () =>
    ({type: 'ACTION_TRACK_STOP'})

export function* trackStopWorker () {
    audio.pause()
    yield put({type:"TRACK_STOP",isPlaying:false,isPaused:true})
}
    export function* trackStopWatcher() {
        yield takeEvery ('ACTION_TRACK_STOP',trackStopWorker)
    }





export const actionTrackVolume = (e) =>
    ({type:'ACTION_TRACK_VOLUME', e})
export function* trackVolumeWorker (action) {
    let {e} = action
    audio.volume = e
    yield put({type:"TRACK_VOLUME", volume:e})
}
export function* trackVolumeWatcher() {
    yield takeEvery ('ACTION_TRACK_VOLUME',trackVolumeWorker)
}




export const actionSetDuration = () => {
    let e = audio.duration
    store.dispatch({type:"TRACK_DURATION",duration:e})
}

export const actionTrackCurrentTime = () => {
    let e = audio.currentTime
    store.dispatch({type:"TRACK_CURRENT_TIME", currentTime:e})
}






export const actionSetPlaylist = (playlist,trackIndex) =>
    ({type:'ACTION_SET_PLAYLIST', playlist,trackIndex})

export function* setPlaylistWorker(action) {
    let {playlist, trackIndex} = action
    console.log (playlist,'trackplay')
    yield put ({type:"SET_PLAYLIST", playlist:playlist})
    yield put (actionTrackPlay(trackIndex))
}

export function* setPlaylistWatcher() {
    yield takeEvery ('ACTION_SET_PLAYLIST',setPlaylistWorker)
}






// export const actionSetDuration = () =>
//     ({type:'ACTION_TRACK_DURATION'})
//
// export function* setDurationWorker () {
//     let e = audio.duration
//     yield put({type:"TRACK_DURATION",duration:e})
// }
//
// export function* setDurationWatcher() {
//     yield takeEvery ('ACTION_TRACK_DURATION',setDurationWorker)
// }
//
//
//
//
// export const actionTrackCurrentTime = () =>
//     ({type:'ACTION_TRACK_CURRENT_TIME'})
// export function* trackCurrentTimeWorker () {
//     let e = audio.currentTime
//     yield put({type:"TRACK_CURRENT_TIME", currentTime:e})
// }
// export function* trackCurrentTimeWatcher() {
//     yield takeEvery ('ACTION_TRACK_CURRENT_TIME', trackCurrentTimeWorker)
// }
